package mvd.jester.priority;

import mvd.jester.model.Task;
import mvd.jester.simulator.internals.TaskContextInterface;

public class RateMonotonic implements PriorityManager {

    /**
     * Compare the priority of two tasks according to the Rate Monotonic policy
     * 
     * @param t1 The first task
     * @param t2 The second task
     * @return 0 if both tasks have the same priority, positive number if the first task has a
     *         higher priority, negative number if the second task has a higher priority
     */
    @Override
    public int compare(Task t1, Task t2) {
        return Long.compare(t1.getPeriod(), t2.getPeriod());
    }

    @Override
    public int compare(TaskContextInterface t1, TaskContextInterface t2) {
        return Long.compare(t1.getTask().getPeriod(), t2.getTask().getPeriod());
    }
}
